//
//  ViewController.swift
//  EmitterKitSample
//
//  Created by oga on 2014/09/23.
//  Copyright (c) 2014年 example. All rights reserved.
//

import UIKit
import EmitterKit

class ViewController: UIViewController {
	var textField : UITextField?
	var listener = [Listener]()
	
	
	override func viewDidLoad() {
		super.viewDidLoad()
		
		
		let counterPrint = Event<NSInteger>() // （１）
		listener.append(counterPrint.on { counter in // （２）
			println("\(counter)")
		})
		counterPrint.emit(1)
		counterPrint.emit(2)
		// sample 1
		emitterSample1()
		
		// signal sample
		signalSample()

		// listener sample
		listenerSample()

		textField = UITextField(frame: CGRectMake(0,100,self.view.frame.size.width, 60))
		self.view.addSubview(textField!)
		
		// notification sample
		notificationSample()
		
	}

	override func viewDidAppear(animated: Bool) {
		self.view.frame = CGRectMake(0,0,100,100)
		self.view.backgroundColor = UIColor.redColor()

		textField?.resignFirstResponder()
		textField?.becomeFirstResponder()
		
	}
	override func didReceiveMemoryWarning() {
		super.didReceiveMemoryWarning()
		// Dispose of any resources that can be recreated.
	}


	func emitterSample1() {
		let counterPrint = Event<NSInteger>()
		
		counterPrint.once { counter in
			println("\(counter)")
		}
		
		counterPrint.emit(1)
		counterPrint.emit(2) // 1度しか呼ばれないためここは処理されない
	}
	func signalSample() {
		let helloSignal = Signal()
		
		helloSignal.once {
			println("hello!")
		}
		
		helloSignal.emit()
		helloSignal.emit() // 1度しか呼ばれないためここは処理されない
	}
	func listenerSample() {
		listener.append(self.view.on("frame") { (values: Change<NSValue>) in
			println(values)
		})
		self.view.once("backgroundColor") { (values: Change<UIColor>) in
			println(values)
		}
	}
	func notificationSample() {
		listener.append(
			Notification(UIKeyboardWillShowNotification).on { data in
				println("keyboard showing. data: \(data)")
			}
		)
		textField?.becomeFirstResponder()
	}
}

